
a, b, c, d, e, f, g, h, i, j, k = range(ord('a'),ord('k')+1)

G1 = [ [a,i], [a,b], [b,a], [b,c], [c,d], [d,e], [e,f],
       [f,g], [g,h], [g,j], [h,i], [i,j] ]


def children(a,G):
    kids = []
    for [x,y] in G:
        if a == x: kids.append(y)
    return kids


def BFS(G, source, dest):
    
    queue = [source]                # the BFS queue                 
    paths = {source: []}            # a dictionary of partial paths
    
    while queue != []:

        a = queue.pop(0)            # next node to explore (first) 
        for b in children(a,G):     # for each possible child node

            if b not in paths:      # b is not yet a key in paths
                
                paths[b] = paths[a] + [(a,b)]  # new path!
                
                if b == dest:       # if b is the destination...
                    return paths[b]            # return the path
                else:
                    queue.append(b) # else go from b in the future 
    return None


def DFS(G, source, dest):
    
    stack = [source]                # the BFS queue                 
    paths = {source: []}            # a dictionary of partial paths
    
    while stack != []:

        a = stack.pop()             # next node to explore (last) 
        for b in children(a,G):     # for each possible child node

            if b not in paths:      # b is not yet a key in paths
                
                paths[b] = paths[a] + [(a,b)]  # new path!
                
                if b == dest:       # if b is the destination...
                    return paths[b]            # return the path
                else:
                    stack.append(b) # else go from b in the future 
    return None



a, b, c, d, e, f, g, h, i, j, k = range(ord('a'),ord('k')+1)

G1 = [ [a,i], [a,b], [b,a], [b,c], [c,d], [d,e], [e,f],
       [f,g], [g,h], [g,j], [h,i], [i,j] ]

def char_path( p ):
    return map( lambda L: map(chr,L), p )
    

if __name__ == "__main__":

    path = BFS( G1, b, j )
    print char_path( path )

    path = DFS( G1, b, j )
    print char_path( path )

